const helper = require('./modules/internal/helper')
const mathHelper = require('./modules/internal/mathHelper')
const oppositeHelper = require('./modules/internal/oppositeHelper')
const propHelper = require('./modules/internal/propHelper')
const simpleHelper = require('./modules/internal/simpleHelper')

exports.add = mathHelper('+') 
exports.addIndex = require("./modules/addIndex")
exports.adjust = require("./modules/adjust")
exports.always = x => () => x
exports.any = require("./modules/any")
exports.append = require("./modules/append")
exports.all = require("./modules/all")
exports.allPass = require("./modules/allPass")
exports.both = require("./modules/both")
exports.compose = require("./modules/compose")
exports.complement = fn => input => !Boolean(fn(input))
exports.concat = oppositeHelper("concat")
exports.contains = require("./modules/contains")
exports.curry = require("./modules/curry")
exports.defaultTo = require("./modules/defaultTo")
exports.divide = mathHelper('/')
exports.drop = require("./modules/drop")
exports.dropLast = require("./modules/dropLast")
exports.either = require("./modules/either")
exports.endsWith = helper("endsWith")
exports.equals = require("./modules/equals")
exports.F = () => false
exports.filter = require("./modules/filter")
exports.find = require("./modules/find")
exports.findIndex = require("./modules/findIndex")
exports.flatten = require("./modules/flatten")
exports.has = require("./modules/has")
exports.head = require("./modules/head")
exports.identity = x => x
exports.ifElse = require("./modules/ifElse")
exports.includes = helper("includes")
exports.indexOf = require("./modules/indexOf")
exports.init = require("./modules/init")
exports.join = helper('join')
exports.last = require("./modules/last")
exports.lastIndexOf = helper("lastIndexOf")
exports.length = propHelper("length")
exports.map = require("./modules/map")
exports.match = require("./modules/match")
exports.merge = require("./modules/merge")
exports.modulo = mathHelper('%')
exports.multiply = mathHelper('*')
exports.not = x => !x
exports.omit = require("./modules/omit")
exports.padEnd = helper('padEnd')
exports.padStart = helper('padStart')
exports.partialCurry = require("./modules/partialCurry")
exports.path = require("./modules/path")
exports.pick = require("./modules/pick")
exports.pluck = require("./modules/pluck")
exports.prepend = require("./modules/prepend")
exports.prop = require("./modules/prop")
exports.propEq = require("./modules/propEq")
exports.range = require("./modules/range")
exports.reduce = require("./modules/reduce")
exports.repeat = require("./modules/repeat")
exports.replace = require("./modules/replace")
exports.reverse = simpleHelper('reverse')
exports.sort = require("./modules/sort")
exports.sortBy = require("./modules/sortBy")
exports.split = require("./modules/split")
exports.splitEvery = require("./modules/splitEvery")
exports.startsWith = helper("startsWith")
exports.subtract = mathHelper('-')
exports.T = () => true
exports.tap = require("./modules/tap")
exports.tail = require("./modules/tail")
exports.take = require("./modules/take")
exports.takeLast = require("./modules/takeLast")
exports.test = require("./modules/testFn")
exports.toLower = simpleHelper("toLowerCase")
exports.toString = simpleHelper('toString')
exports.toUpper = simpleHelper("toUpperCase")
exports.trim = simpleHelper("trim")
exports.type = require("./modules/type")
exports.uniq = require("./modules/uniq")
exports.update = require("./modules/update")
exports.values = require("./modules/values")
